﻿using QScalp.History.Reader;
using StockSharp.BusinessEntities;
using StockSharp.Messages;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using StockSharp.Algo;
using StockSharp.Algo.Storages;
using System.Collections;
using System.IO;
//using StorageDatas;
//using StorageTraders;         


namespace Scalps
{
    public class SaveMessages
    {
        string _fname, _folderDest;
        Security _secur;
        private SortedDictionary<DateTime, StockSharp.Messages.Message> _levs, _trades, _quotes;
        private QshReader _qr;
        private SecurityId _securId;
        private DateTime _start;
        private string _shortId, _securyId;
        private string _shCode;
        private DateTime _lastTradeTime;
        public Array Frames { get; set; }
        public Security Secur { get { return _secur; } }
        public bool IsSaveToBin { get; set; }
        public bool IsCalcVol { get; set; }
        public bool IsVolume { get; set; }
        public Trade[] TradesAll { get; set; }
        public Action<SaveMessages, IEnumerable<Message>> ActSave { get; set; }
        public Dictionary<string, string> Maps { get; set; }
        public IEnumerable<Security> Secures { get; set; }
        public DateTime Start { get { return _start; } }
        public SaveMessages(string fn, string foldDest, string securId, DateTime start)
        {
            _fname = fn;
            _folderDest = foldDest;
            _start = start;
            _securyId = securId;
            _levs = new SortedDictionary<DateTime, StockSharp.Messages.Message>();
            _trades = new SortedDictionary<DateTime, StockSharp.Messages.Message>();
            _quotes = new SortedDictionary<DateTime, StockSharp.Messages.Message>();
            IsSaveToBin = true;
        }
        private void AddTrades()
        {
            if (TradesAll == null || TradesAll.Length == 0) return;
            var dic = new Dictionary<long, ExecutionMessage>();
            //foreach(var exe in _trades.Values)
        }
        public void Execute()
        {
            var sa = _securyId.Split(new char[] {'@'});
            _secur = Secures.FirstOrDefault(p => p.Id == _securyId);
            if (_secur == null) return;
            _securId = _secur.ToSecurityId();
            _shortId = _secur.Board.Code == "FORTS" ? _secur.Id.Substring(0, 2) : _secur.Code;
            _shCode = Maps[_shortId];

            _qr = QshReader.Open(_fname);
            IDealsStream s = (IDealsStream)_qr[0];
            s.Handler += DealsHandler;
            //IOrdLogStream so = (IOrdLogStream)_qr[0];
            //so.Handler += OrdLogHandler;
            //IAuxInfoStream saux = (IAuxInfoStream)_qr[0];
            //saux.Handler += AuxInfoHandler;

            IStockStream ss = (IStockStream)_qr[0];
            // Добавляем обработчик читаемых данных. При этом если в
            // исходном файле несколько потоков со стаканом, они все
            // будут обрабатываться этим обработчиком. Различать исходные
            // потоки одного типа мы будем уже внутри обработчика.
            ss.Handler += StockHandler;
            int lastPercent = 0;
            while (_qr.CurrentDateTime != DateTime.MaxValue)
            {
                // Выведем, какой процент исходного файла уже обработали. Если
                // исходные файл сжат, то это значение может быть немного
                // некорректно (особенно для небольших файлов), т.к. сжатый файл
                // читается большими блоками.

                int percent = (int)(100 * _qr.FilePosition / _qr.FileSize);
                if (lastPercent != percent)
                {
                    lastPercent = percent;
                    //Console.Write("\r{0}%", percent);
                }

                // Прочтем кадр исходного файла. Параметр push задает вызывать ли
                // при этом обработчик или нет. После возврата из метода свойства
                // qr.CurrentDateTime и qr.CurrentStreamIndex будут содержать
                // значения для следующего кадра.
                _qr.Read(true);
            }
            var trds = _trades.Values.Where(p => p.LocalTime.TimeOfDay <= new TimeSpan(10, 1, 0)).ToArray();
            var vol = trds.Sum(p => ((ExecutionMessage)p).Volume);
            if (IsSaveToBin)
            {
                var dtn = string.Format("{0,4:0000}_{1,2:00}_{2,2:00}", _start.Year, _start.Month, _start.Day);
                var dir = Path.Combine(_folderDest, _secur.Id, dtn);
                if (Directory.Exists(dir))
                    Directory.Delete(dir, true);
                var storage = new StorageRegistry
                {
                    // изменяем путь, используемый по умолчанию
                    DefaultDrive = new LocalMarketDataDrive(_folderDest)
                };
                ((LocalMarketDataDrive)storage.DefaultDrive).UseAlphabeticPath = false;
                StorageFormats fmt = StorageFormats.Binary;
                var exec = storage.GetExecutionStorage(_secur, StockSharp.Messages.ExecutionTypes.Tick, storage.DefaultDrive, fmt);
                try
                {
                    exec.Save(_trades.Values);
                    //var trs = exec.Load(new DateTime(2015, 4, 8), new DateTime(2015, 4, 8, 23,0,0)).ToArray();
                    //var trs3 = exec.Load(_trades.ElementAt(0).Key, _trades.Last().Key).ToArray();
                    //var trs2 = exec.Load(_trades.ElementAt(0).Key, _trades.ElementAt(0).Key.Date + TimeSpan.FromHours(24)).ToArray();
                }
                catch
                {
                }
                //var lev1 = storage.GetLevel1MessageStorage(security, storage.DefaultDrive, fmt);
                var quot = storage.GetQuoteMessageStorage(_secur, storage.DefaultDrive, fmt);
                try
                {
                    quot.Save(_quotes.Values);
                }
                catch
                {
                }
                var lev1 = storage.GetLevel1MessageStorage(_secur, storage.DefaultDrive, fmt);
                try
                {
                    lev1.Save(_levs.Values);
                }
                catch
                {
                }
            }
            if (ActSave != null)
            {
                ActSave(this, _trades.Values);
                //ActSave(_quotes.Values);
                //ActSave(_levs.Values);
            }
            //_levs.Clear();
            //((IEnumerable<ExecutionMessage>)_trades.Values.ToArray()).Sav
        }
        private void StockHandler(QScalp.Security secur, QScalp.Quote[] quotes, QScalp.Spread spread, DateTime date)
        {
            if (spread.Bid > spread.Ask || date < _start) return;
            var quote = new QuoteChangeMessage();
            quote.SecurityId = _securId;// new SecurityId() { SecurityCode = Secur.Code, BoardCode = Secur.Board.Code };
            quote.ServerTime = date;
            quote.LocalTime = date;
            var bids = new List<TimeQuoteChange>();
            var asks = new List<TimeQuoteChange>();
            foreach (QScalp.Quote q in quotes)
            {
                var tm = new TimeQuoteChange()
                {
                    SecurityId = _securId,
                    BoardCode = _securId.BoardCode,
                    LocalTime = date,
                    ServerTime = date,
                    Price = Convert.ToDecimal(q.Price * _secur.PriceStep),
                    Volume = Convert.ToDecimal(q.Volume),
                    Side = q.Type == QScalp.QuoteType.Ask ? Sides.Sell : Sides.Buy
                };
                if (q.Type == QScalp.QuoteType.Ask)
                    asks.Add(tm);
                else 
                    bids.Add(tm);
            }
            quote.Bids = bids.OrderByDescending(p => p.Price).ToArray();
            quote.Asks = asks.OrderBy(p => p.Price).ToArray();
            _quotes[date] = quote;

            var lev1 = new Level1ChangeMessage();
            lev1.SecurityId = _securId;// new SecurityId() { SecurityCode = Secur.Code, BoardCode = Secur.Board.Code };
            lev1.ServerTime = date;
            lev1.LocalTime = date;
            lev1.Changes.Add(Level1Fields.BestAskPrice, Convert.ToDecimal(spread.Ask * _secur.PriceStep));
            lev1.Changes.Add(Level1Fields.BestBidPrice, Convert.ToDecimal(spread.Bid * _secur.PriceStep));
            //lev1..Type = MessageTypes.Level1Change;
            _levs[date] = lev1;
            //StockSharp.BusinessEntities.Trade tr;tr.
            //((StockStream)streams[qr.CurrentStreamIndex]).Write(qr.CurrentDateTime, quotes);
        }

        private void DealsHandler(QScalp.Deal deal, QScalp.Security secur)
        {
            if (deal.DateTime >= _start && secur.Entry.Contains(_shCode))
            {
                var exe = new ExecutionMessage()
                {
                    SecurityId = _securId,
                    ServerTime = deal.DateTime,
                    LocalTime = deal.DateTime,
                    ExecutionType = ExecutionTypes.Tick,
                    TradeId = deal.Id,
                    Volume = Convert.ToDecimal(deal.Volume),
                    TradePrice = Convert.ToDecimal(deal.Price),
                    OriginSide = deal.Type == QScalp.DealType.Buy ? Sides.Buy : deal.Type == QScalp.DealType.Sell ? Sides.Sell : (Sides?)null,
                    OpenInterest = Convert.ToDecimal(deal.OI)
                };
                if (!_trades.ContainsKey(deal.DateTime))
                {
                    _trades[deal.DateTime] = exe;
                    _lastTradeTime = deal.DateTime;
                }
                else
                {
                    var last = deal.DateTime;
                    while (_trades.ContainsKey(last))
                    {
                        last = last.AddMilliseconds(1);
                    }
                    exe.LocalTime = last;
                    exe.ServerTime = last;
                    //    var ex = (ExecutionMessage)_trades[last];
                    //    if (ex.TradePrice == exe.TradePrice && ex.OriginSide == exe.OriginSide)
                    //    {
                    //        ex.Volume += exe.Volume;
                    //        if (exe.TradeId > ex.TradeId)
                    //            ex.OpenInterest = exe.OpenInterest;
                    //        return;
                    //    } else last = last.AddMilliseconds(1);
                    //}
                    _trades[last] = exe;
                }
            }
            //((DealsStream)streams[qr.CurrentStreamIndex]).Write(qr.CurrentDateTime, deal);
        }
        private void AuxInfoHandler(QScalp.Security secur, QScalp.AuxInfo aux)
        {
            //aux.
            //lev1 = new Level1ChangeMessage();
            //lev1.SecurityId = Secur.ToSecurityId();// new SecurityId() { SecurityCode = Secur.Code, BoardCode = Secur.Board.Code };
            //lev1.ServerTime = d;
            //lev1.LocalTime = d;
        }

        //private void OrdLogHandler(int skey, QScalp.OrdLogEntry entry)
        //{
        //    ((OrdLogStream)streams[qr.CurrentStreamIndex]).Write(qr.CurrentDateTime, entry);
        //}
    }
}
